Subject: Re: [PATCH net-next] sunvnet: call unregister_netdev() exactly once per device

From: Sowmini Varadhan <[email-masked]>
Date: Wed, 09 Jul 2014 07:27:26 -0400

On 07/08/2014 11:42 PM, David Miller wrote:

>
> This is definitely not the right fix, you're just removing a symptom
> of a much larger problem.
>
> And that problem is that nothing cleans up the objects created by
> vnet_new(), they are completely leaked.

the bug(s) in modprobe -r is one manifestation of the problem
and should certainly be fixed, I can look into the suggestions
you have below.

But this is actually a bit worse. Whenever a node goes
away, it triggers a vio_port_remove() on all the peering nodes,
and blows away their networking. IOW this can happen without
involving vnet_exit() at all. Thus it might be necessary
for vio_port_remove() itself to check if its the last port
before doing the unregister?

BTW, for some odd reason I did not see my original patch submission
show up in the list. I'm not sure why.

>
> vnet_exit(), after doing the vio_unregister_driver(), should call a
> helper function that iterates over vnet_list and cleans up those
> objects.
>
> That's where the unregister_netdevice() belongs, not in vnet_port_remove().
> --
> To unsubscribe from this list: send the line "unsubscribe netdev" in
> the body of a message to [email-masked]
> More majordomo info at  http://vger.kernel.org/majordomo-info.html
>